package com.unissoft.intrusion;

import cn.hutool.core.convert.Convert;
import com.unissoft.common.MyConstant;
import com.unissoft.utils.RedisUtil;
import lombok.extern.slf4j.Slf4j;
import org.redisson.transaction.HashKey;
import org.springframework.stereotype.Service;
import org.springframework.util.CollectionUtils;
import org.springframework.util.MultiValueMap;

import javax.annotation.Resource;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.nio.ByteBuffer;
import java.text.SimpleDateFormat;
import java.util.*;
import java.util.stream.Collectors;

/**
 * @author qingsong.han
 * @description:
 * @create 2022-11-14 17:32
 */
public interface GetIntrusionService {

    Object pullIntrusion();
    // 定义内部类
    @Slf4j
    @Service
    class IntrusionServiceImpl implements GetIntrusionService {
        @Resource
        private RedisUtil redisUtil;

        @Override
        public Object pullIntrusion() {
            if (redisUtil.hasKey(MyConstant.INTRUSION_ALARM_IP)) {
                Map<String, Object> hmget = redisUtil.hmget(MyConstant.INTRUSION_ALARM_IP);
                // 转list
                if (!CollectionUtils.isEmpty(hmget)) {
                    Collection<Object> values = hmget.values();
                    Iterator iterator = values.iterator();
                    log.info("values:{}", values);
                    while(iterator.hasNext()){
                        log.info("next item:{}",iterator.next());
                    }
                    //MultiValueMap<String, Object> newVal = (MultiValueMap)values;
                    //log.info("pullIntrusion, deviceIP:{}, cameraIP:{}", newVal.get("deviceIP"), newVal.get("cameraIP"));
/*
                    MultiValueMap<String, Object> newVal = (MultiValueMap)values;
                    System.out.println("ip:" + newVal.get("cameraIP"));

                    SimpleDateFormat sf = new SimpleDateFormat("yyyyMMddHHmmss");
                    String newName = sf.format(new Date());
                    FileOutputStream fout;
                    try {
                        File file = new File( ".//pic//");
                        if(!file.exists())
                            file.mkdir();
                        String filename = ".//pic//" + newName + "VCA_TRAVERSE_PLANE" + ".jpg";
                        fout = new FileOutputStream(filename);
                        //将字节写入文件
                        Byte[]  oBytes = Convert.toByteArray(newVal.get("pic"));
                        byte[] bytes = new byte[oBytes.length];

                        for(int i = 0; i < oBytes.length; i++) {
                            bytes[i] = oBytes[i];
                        }
                        fout.write(bytes);
                        fout.close();
                    } catch (FileNotFoundException e) {
                        // TODO Auto-generated catch block
                        e.printStackTrace();
                    } catch (IOException e) {
                        // TODO Auto-generated catch block
                        e.printStackTrace();
                    }*/
                    // 成功返回数据,清除redis缓存
                    redisUtil.del(MyConstant.INTRUSION_ALARM_IP);


                    return values;
                }
            }
            return Collections.emptyList();
        }
    }

}
