package com.unissoft.intrusion;

import lombok.extern.slf4j.Slf4j;
import org.apache.tomcat.util.codec.binary.Base64;
import org.springframework.util.ClassUtils;
import org.springframework.web.bind.annotation.*;

import javax.annotation.Resource;
import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.Map;

/**
 * @author qingsong.han
 * @description: 接收库点摄像头信息
 * @create 2022-11-07 10:19
 */
@Slf4j
@RestController
public class IntrusionController {
    @Resource
    private IntrusionService intrusionService;

    // 接收库点海康摄像头异常信息
    /*
    @PostMapping("/pushIntrusion")
    public void pushIntrusion(Integer sAlarmType, String alarmNow, String deviceIP, String orgCode,
                              String cameraIP, String bytes, Integer size) {
        intrusionService.pushIntrusion(sAlarmType, alarmNow, deviceIP, orgCode, cameraIP, bytes, size);
    }
    */
    @RequestMapping("/pushIntrusion")
    @ResponseBody
    public void pushIntrusion(@RequestParam Map<String,String> map){
        Integer alarmType = Integer.parseInt(map.get("sAlarmType").toString());
        String alarmNow = map.get("alarmNow").toString();
        String deviceIP = map.get("deviceIP").toString();
        String orgCode = map.get("orgCode").toString();
        String cameraIP = "";
        String picByte = "";
        Integer size = 0;
        if(map.containsKey("picByte")) {
            cameraIP = map.get("cameraIP").toString();
            picByte = map.get("picByte").toString();
            size = Integer.parseInt(map.get("sAlarmType").toString());
        }
        intrusionService.pushIntrusion(alarmType, alarmNow, deviceIP, orgCode, cameraIP, picByte, size);

        byte[] bytes = Base64.decodeBase64(picByte); // Base64解码
        //将字节写入文件
        SimpleDateFormat sf = new SimpleDateFormat("yyyyMMddHHmmss");
        String newName = sf.format(new Date());
        FileOutputStream fout;
        String path = "." + File.separator + "pic" + File.separator + newName + "_pSnapPicBuffer" + ".jpg";
        System.out.println("path:"+ path);
        FileOutputStream fis = null;
        try {
            File file =new File(path);
            file.createNewFile();
            fis = new FileOutputStream(file);
            fis.write(bytes);
        } catch (IOException e) {
            e.printStackTrace();
        } finally {
            if (fis != null) {
                try {
                    fis.close();
                } catch (IOException e) {
                    e.printStackTrace();
                }
            }
        }

    }


    // 修改ICC通道号编码接口ICC_CHANNEL_CODE key:value(IP:channelCode)
    @GetMapping("/editChannelCode")
    public void editChannelCode(@RequestParam Map<String, String> channelCodes) {
        intrusionService.editChannelCode(channelCodes);
    }
}
